﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Interlight
{
    public partial class DownloadDialog : Form
    {
        public DownloadDialog(string url)
        {
            InitializeComponent();
            urlLbl.Text = url;

            extDetails.Text = "[" + Path.GetExtension(url) + "] ";

            String ext = Path.GetExtension(url).ToLower();

            if (ext == ".exe" || ext == ".jar")
            {
                extDetails.Text = extDetails.Text + "This is an executable file. This kind of file can potentially harm your computer, although there are many safe and useful executable files out there.";
            }
            else if (ext == ".zip" || ext == ".rar" || ext == ".7z")
            {
                extDetails.Text = extDetails.Text + "This is a compressed archive. This kind of file contains other files inside itself.";
            }
            else if (ext == ".mp3" || ext == ".wav" || ext == ".ogg" || ext == ".wma")
            {
                extDetails.Text = extDetails.Text + "This is an audio file.";
            }
            else if (ext == ".html" || ext == ".htm")
            {
                extDetails.Text = extDetails.Text + "This is an HTML file. This file is used to display content inside a web browser. This file may contain or link to harmful content.";
            }
            else if (ext == ".avi" || ext == ".mp4" || ext == ".wmv" || ext == ".mov")
            {
                extDetails.Text = extDetails.Text + "This is a video file. Video files tend to have a big file size, resulting in more bandwidth and time needed to download.";
            }
            else if (ext == ".png" || ext == ".jpg" || ext == ".jpeg" || ext == ".gif" || ext == ".ico" || ext == ".tiff" || ext == ".raw")
            {
                extDetails.Text = extDetails.Text + "This is an image file.";
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Form1.lastDlURL = "";
            this.Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Form1.lastDlURL = "";
            String dir = "";

            try
            {
                System.IO.File.WriteAllText(Environment.ExpandEnvironmentVariables("%HOMEPATH%") + "\\Downloads\\InterlightTest.txt", ".");
                System.IO.File.Delete(Environment.ExpandEnvironmentVariables("%HOMEPATH%") + "\\Downloads\\InterlightTest.txt");
                //SUCCESS
            }
            catch
            {
                try
                {
                    System.IO.Directory.CreateDirectory(Environment.ExpandEnvironmentVariables("%HOMEPATH%") + "\\Downloads");
                    //SUCCESS
                }
                catch
                {
                    //Failure
                    MessageBox.Show("The Downloads directory is unaccessible.");
                    return;
                }
            }

            if (System.IO.File.Exists(Environment.ExpandEnvironmentVariables("%HOMEPATH%") + "\\Downloads\\" + System.IO.Path.GetFileName(urlLbl.Text)))
            {
                int extraNumber = 1;
                bool found = false;

                while (found == false)
                {
                    if (System.IO.File.Exists(Environment.ExpandEnvironmentVariables("%HOMEPATH%") + "\\Downloads\\" + System.IO.Path.GetFileNameWithoutExtension(urlLbl.Text) + " (" + extraNumber + ")" + System.IO.Path.GetExtension(urlLbl.Text)))
                    {
                        extraNumber++;
                    }
                    else
                    {
                        found = true;
                        dir = Environment.ExpandEnvironmentVariables("%HOMEPATH%") + "\\Downloads\\" + System.IO.Path.GetFileNameWithoutExtension(urlLbl.Text) + " (" + extraNumber + ")" + System.IO.Path.GetExtension(urlLbl.Text);
                    }
                }
            }
            else
            {
                dir = Environment.ExpandEnvironmentVariables("%HOMEPATH%") + "\\Downloads\\" + System.IO.Path.GetFileName(urlLbl.Text);
            }

            try
            {
                DownloadProgress progress = new DownloadProgress(urlLbl.Text, dir);
                progress.Show();
            }
            catch { }
            this.Close();
        }

        SaveFileDialog sfd = new SaveFileDialog();
        private void button2_Click(object sender, EventArgs e)
        {
            sfd.Filter = "All Files|*.*";
            sfd.FileName = System.IO.Path.GetFileName(urlLbl.Text);
            sfd.ShowDialog();
        }

        void sfd_FileOk(object sender, CancelEventArgs e)
        {
            Form1.lastDlURL = "";

            DownloadProgress progress = new DownloadProgress(urlLbl.Text, sfd.FileName);
            progress.Show();
            this.Close();
            sfd.Dispose();
        }

        private void DownloadDialog_Load(object sender, EventArgs e)
        {
            sfd.FileOk += sfd_FileOk;
        }
    }
}
