﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Interlight
{
    public partial class DownloadProgress : Form
    {
        String Directory;
        System.Net.WebClient client = new System.Net.WebClient();

        /// <summary>
        /// The form to use when downloading files.
        /// </summary>
        /// <param name="url">The URL of the download.</param>
        /// <param name="directory">The exact path you want to save the downloaded file in.</param>
        public DownloadProgress(String url, String directory)
        {
            InitializeComponent();
            Properties.Settings.Default.dlHistory.Add(url);
            Properties.Settings.Default.Save();
           
            Directory = directory;
            //   %HOMEPATH%\\Downloads

            try
            {
                client.DownloadFileAsync(new Uri(url), directory);
            }
            catch
            {
                MessageBox.Show("Downloading failed.");
                client.CancelAsync();
                this.Close();
            }
        }

        private void showBtns()
        {
            button1.Enabled = true;
            button2.Enabled = true;
        }

        void client_DownloadFileCompleted(object sender, AsyncCompletedEventArgs e)
        {
            dlLbl.Text = "download finished";
            this.Text = "Interlight - Download complete";
            button3.Visible = false;
            if (close.Checked == true)
            {
                try
                {
                    System.Diagnostics.Process.Start(Directory);
                }
                catch { }
                showBtns();
                this.Close();
            }
            else
            {
                showBtns();
                close.Visible = false;
            }
            client.Dispose();
        }

        void client_DownloadProgressChanged(object sender, System.Net.DownloadProgressChangedEventArgs e)
        {
            pb.Value = e.ProgressPercentage;
        }

        private void close_CheckedChanged(object sender, EventArgs e)
        {
            if (dlLbl.Text == "download finished" && close.Checked == true)
            {
                this.Close();
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            try
            {
                System.Diagnostics.Process.Start(Directory);
            }
            catch
            {
            }
            this.Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                string filePath = @Directory;

                // Combine the arguments together
                // It doesn't matter if there is a space after ','
                string argument = @"/select, " + filePath;

                System.Diagnostics.Process.Start("explorer.exe", argument);
            }
            catch
            {
                MessageBox.Show("The directory failed to open.");
            }
            this.Close();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            client.CancelAsync();
            this.Close();
        }

        private void DownloadProgress_FormClosing(object sender, FormClosingEventArgs e)
        {
            client.CancelAsync();
            client.Dispose();
        }

        private void DownloadProgress_Load(object sender, EventArgs e)
        {
            client.DownloadProgressChanged += client_DownloadProgressChanged;
            client.DownloadFileCompleted += client_DownloadFileCompleted;
        }
    }
}
