﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Net;
using System.Diagnostics;
using Awesomium.Core;
using Awesomium.Windows.Forms;

namespace Interlight
{
    public partial class Form1 : Form
    {
        //The primary webbrowser array
        WebControl[] browsers = new WebControl[100];

        #region Class Variables
        WebSession session;
        public static String lastDlURL = "";
        public static String customDownloadURL = "";
        SaveFileDialog sourcesfd = new SaveFileDialog();
        Boolean isManualSavePage = false;
        String saveWebpageFilenameWithoutExtension;
        private PopupMenuEventArgs _MenuArgs;
        int rightClickedTab = 0;
        String sourceImage;
        Boolean closing = false;
        Boolean cancelHome = false;
        public Timer warn = new Timer();
        Boolean loadTinfoil = false;
        String lastTabOpen = Properties.Settings.Default.homeUrl;
        #endregion

        public Form1(string[] args)
        {
            InitializeComponent();
            //Load the arguments
            foreach (string s in args)
            {
                if (s == "interlight:tinfoil")
                {
                    //In tinfoil mode
                    tinfoilLbl.Visible = true;
                    cancelHome = true;
                    loadTinfoil = true;
                }
                else
                {
                    cancelHome = true;
                    try
                    {
                        browsers[bTabs.SelectedIndex].Source = (new Uri(s));
                    }
                    catch
                    {
                        try
                        {
                            browsers[bTabs.SelectedIndex].Source = (new Uri("http://" + s));
                        }
                        catch
                        {
                            MessageBox.Show("Failed to navigate.");
                        }
                    }
                }
            }

            if (loadTinfoil == false)
            {
                try
                {
                    session = WebCore.CreateWebSession("C:\\SessionDataPath", WebPreferences.Default);
                }
                catch
                {
                    DialogResult dr = MessageBox.Show("Oops! Due to Awesomium's limitations, you can only open Interlight one instance at a time. Do you want to close the running instance manually?", "Interlight", MessageBoxButtons.YesNo);
                    if (dr == System.Windows.Forms.DialogResult.Yes)
                    {
                        System.Diagnostics.Process.Start("Taskmgr.exe");
                    }
                    else
                    {
                        this.Close();
                    }
                }
            }
        }

        private void WebCore_Download(object sender, DownloadEventArgs e)
        {
            //Cancel the default WebCore downloader
            e.Cancel = true;

            //Making sure that the download URL isn't being spammed
            if (lastDlURL != e.Url.ToString())
            {
                lastDlURL = e.Url.ToString();
                DownloadDialog dl = new DownloadDialog(e.Url.ToString());
                dl.Show();
            }
        }

        private void search()
        {
            String search = Properties.Settings.Default.searchEngine;

            #region Default Search engine selection
            //Making sure Interlight is searching using the search engine selected in the settings!
            switch (search)
            {
                case "bing":
                    browsers[bTabs.SelectedIndex].Source = new Uri("http://www.bing.com/search?q=" + url.Text);
                    break;
                case "google":
                    browsers[bTabs.SelectedIndex].Source = new Uri("https://www.google.com/search?q=" + url.Text);
                    break;
                case "yahoo":
                    browsers[bTabs.SelectedIndex].Source = new Uri("http://search.yahoo.com/search?p=" + url.Text);
                    break;
                case "wikipedia":
                    browsers[bTabs.SelectedIndex].Source = new Uri("http://en.wikipedia.org/w/index.php?search=" + url.Text);
                    break;
                case "amazon":
                    browsers[bTabs.SelectedIndex].Source = new Uri("http://www.amazon.com/s/&field-keywords=" + url.Text);
                    break;
                case "baidu":
                    browsers[bTabs.SelectedIndex].Source = new Uri("http://www.baidu.com/s?wd=" + url.Text);
                    break;
                case "naver":
                    browsers[bTabs.SelectedIndex].Source = new Uri("http://search.naver.com/search.naver?query=" + url.Text);
                    break;
            }
            #endregion
        }

        private void backToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Try going back
            try
            {
                browsers[bTabs.SelectedIndex].GoBack();
            }
            catch { }
        }

        private void forwardToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Try going forward
            try
            {
                browsers[bTabs.SelectedIndex].GoForward();
            }
            catch { }
        }

        private void homeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Try going home!

            #region goHomeCode
            try
            {
                browsers[bTabs.SelectedIndex].Source = new Uri(Properties.Settings.Default.homeUrl);
            }
            catch
            {
                try
                {
                    browsers[bTabs.SelectedIndex].Source = (new Uri("http://" + Properties.Settings.Default.homeUrl));
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Failed to navigate. Invalid home page URL, please check that!"
                        + Environment.NewLine + Environment.NewLine + "Detail:" + Environment.NewLine + ex);
                }
            }
            #endregion
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            #region general init
            browsers[0] = new WebControl();

            //If you want to edit one of the init properties, make sure to change the
            //properties set in newTab() too!
            browsers[0].WebSession = session;
            bTabs.TabPages[0].Controls.Add(browsers[0]);
            browsers[0].Dock = DockStyle.Fill;
            url.Text = browsers[0].Title;
            bTabs.TabPages.Add("+");
            addEvents(0);

            //Resize based on the size of the form on the last close
            if (Properties.Settings.Default.isMax == true)
            {
                this.WindowState = FormWindowState.Maximized;
            }
            else
            {
                this.Size = Properties.Settings.Default.formSize;
            }
            
            if (loadTinfoil == true)
            {
                browsers[bTabs.SelectedIndex].Source = new Uri("http://mobilemp.net/Interlight/tinfoil/tinpage.html");
            }

            else if (cancelHome == false)
            {
                if (Properties.Settings.Default.popup != "NONE")
                {
                    try
                    {
                        browsers[bTabs.SelectedIndex].Source = new Uri(Properties.Settings.Default.popup);
                    }
                    catch
                    {
                        try
                        {
                            browsers[bTabs.SelectedIndex].Source = new Uri("http://" + Properties.Settings.Default.popup);
                        }
                        catch
                        {
                            MessageBox.Show("Failed to navigate.");
                        }
                    }
                    Properties.Settings.Default.popup = "NONE";
                }
                else
                {
                    //Let's try to go home!
                    try
                    {
                        browsers[bTabs.SelectedIndex].Source = new Uri(Properties.Settings.Default.homeUrl);
                        url.Text = Properties.Settings.Default.homeUrl;
                    }
                    catch
                    {
                        try
                        {
                            browsers[bTabs.SelectedIndex].Source = new Uri("http://" + Properties.Settings.Default.homeUrl);
                            url.Text = Properties.Settings.Default.homeUrl;
                        }
                        catch
                        {
                            MessageBox.Show("Failed to navigate.");
                        }
                    }
                }
                browsers[bTabs.SelectedIndex].Select();
            }
            cancelHome = false;

            #endregion

            //Create tooltips
            ToolTip tt = new ToolTip();
            tt.SetToolTip(warningBox, "The security certificate for this website has an error. It is highly recommended you do not perform payments through this website, as it may be malicious.");
            
            //Subscribe to some event handlers here
            WebCore.Download += WebCore_Download;
            sourcesfd.FileOk += sfd_FileOk;
            warn.Tick += new EventHandler(timer_Tick);
        }

        void timer_Tick(object sender, EventArgs e)
        {
            warn.Enabled = false;
            this.Opacity = 1;
        }

        private void historyToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            try
            {
                settings obj = new settings();
                obj.currentPage(browsers[bTabs.SelectedIndex].Source.ToString());
                obj.selectTab(2);
                obj.ShowDialog();
            }
            catch { }

            //CHECK IF NAVIGATION IS REQUESTED
            if (Properties.Settings.Default.navigateTo != "NONE")
            {
                try
                {
                    browsers[bTabs.SelectedIndex].Source = (new Uri(Properties.Settings.Default.navigateTo));
                }
                catch
                {
                    try
                    {
                        browsers[bTabs.SelectedIndex].Source = new Uri("http://" + Properties.Settings.Default.navigateTo);
                    }
                    catch
                    {
                        MessageBox.Show("Failed to navigate.");
                    }
                }
                Properties.Settings.Default.navigateTo = "NONE";
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            //Save window size
            if (this.WindowState == FormWindowState.Maximized)
            {
                Properties.Settings.Default.isMax = true;
                Properties.Settings.Default.Save();
            }
            else
            {
                Properties.Settings.Default.isMax = false;
                Properties.Settings.Default.formSize = this.Size;
                Properties.Settings.Default.Save();
            }

            if (Application.OpenForms.Count == 1 && closing == false)
            {
                e.Cancel = true;
                closing = true;
                Application.Exit();
            }
        }

        private void historyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                settings obj = new settings();
                obj.currentPage(browsers[bTabs.SelectedIndex].Source.ToString());
                obj.selectTab(3);
                obj.ShowDialog();
            }
            catch { }

            //CHECK IF NAVIGATION IS REQUESTED
            if (Properties.Settings.Default.navigateTo != "NONE")
            {
                try
                {
                    browsers[bTabs.SelectedIndex].Source = new Uri(Properties.Settings.Default.navigateTo);
                }
                catch
                {
                    try
                    {
                        browsers[bTabs.SelectedIndex].Source = new Uri("http://" + Properties.Settings.Default.navigateTo);
                    }
                    catch
                    {
                        MessageBox.Show("Failed to navigate.");
                    }
                }
                Properties.Settings.Default.navigateTo = "NONE";
            }
        }

        private void settingsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                settings obj = new settings();
                obj.currentPage(browsers[bTabs.SelectedIndex].Source.ToString());
                obj.selectTab(0);
                obj.ShowDialog();
            }
            catch { }

            //CHECK IF NAVIGATION IS REQUESTED
            if (Properties.Settings.Default.navigateTo != "NONE")
            {
                try
                {
                    browsers[bTabs.SelectedIndex].Source = new Uri(Properties.Settings.Default.navigateTo);
                }
                catch
                {
                    try
                    {
                        browsers[bTabs.SelectedIndex].Source = new Uri("http://" + Properties.Settings.Default.navigateTo);
                    }
                    catch
                    {
                        MessageBox.Show("Failed to navigate.");
                    }
                }
                Properties.Settings.Default.navigateTo = "NONE";
            }
        }

        private void newWindowToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string[] args = { };
            Form1 frm = new Form1(args);
            frm.Show();
        }

        private void Awesomium_Windows_Forms_WebControl_TitleChanged(object sender, Awesomium.Core.TitleChangedEventArgs e)
        {
            if (e.Title != "")
            {
                bTabs.TabPages[bTabs.SelectedIndex].Text = e.Title;
            }
            else
            {
                bTabs.TabPages[bTabs.SelectedIndex].Text = browsers[bTabs.SelectedIndex].Source.ToString();
            }
        }

        private void Awesomium_Windows_Forms_WebControl_WindowClose(object sender, Awesomium.Core.WindowCloseEventArgs e)
        {
            this.Close();
        }

        private void httpView_ShowCreatedWebView(object sender, Awesomium.Core.ShowCreatedWebViewEventArgs e)
        {
            string[] args = { e.TargetURL.ToString() };
            Form1 frm = new Form1(args);
            frm.Show();

            if (browsers[bTabs.SelectedIndex].HasTitle)
            {
                bTabs.TabPages[bTabs.SelectedIndex].Text = browsers[bTabs.SelectedIndex].Title;
            }
            else
            {
                bTabs.TabPages[bTabs.SelectedIndex].Text = browsers[bTabs.SelectedIndex].Source.ToString();
            }

            try
            {
                sourceImage = "http://" + browsers[bTabs.SelectedIndex].Source.Host + "/favicon.ico";
                WebRequest request = (WebRequest)WebRequest.Create(sourceImage);
                request.BeginGetResponse(GetCallback, request);
            }
            catch { favicon.Image = null; }
        }

        private void refreshToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                //Reload page and dispose of cache
                browsers[bTabs.SelectedIndex].Reload(true);
            }
            catch { }
        }

        private void Awesomium_Windows_Forms_WebControl_LoadingFrame(object sender, Awesomium.Core.LoadingFrameEventArgs e)
        {
            pb.Value = 50;
        }

        private void Awesomium_Windows_Forms_WebControl_LoadingFrameComplete(object sender, Awesomium.Core.FrameEventArgs e)
        {
            pb.Value = 100;

            if (browsers[bTabs.SelectedIndex].Source.AbsolutePath == e.Url.AbsolutePath)
            {
                if (browsers[bTabs.SelectedIndex].HasTitle)
                {
                    bTabs.TabPages[bTabs.SelectedIndex].Text = browsers[bTabs.SelectedIndex].Title;
                }
                else
                {
                    bTabs.TabPages[bTabs.SelectedIndex].Text = browsers[bTabs.SelectedIndex].Source.ToString();
                }

                try
                {
                    sourceImage = "http://" + browsers[bTabs.SelectedIndex].Source.Host + "/favicon.ico";
                    WebRequest request = (WebRequest)WebRequest.Create(sourceImage);
                    request.BeginGetResponse(GetCallback, request);
                }
                catch { favicon.Image = null; }
            }
        }

        private void Awesomium_Windows_Forms_WebControl_LoadingFrameFailed(object sender, Awesomium.Core.LoadingFrameFailedEventArgs e)
        {
            try
            {
                pb.Value = 100;
                if (browsers[bTabs.SelectedIndex].Source.AbsolutePath == e.Url.AbsolutePath)
                {
                    if (browsers[bTabs.SelectedIndex].HasTitle)
                    {
                        bTabs.TabPages[bTabs.SelectedIndex].Text = browsers[bTabs.SelectedIndex].Title;
                    }
                    else
                    {
                        bTabs.TabPages[bTabs.SelectedIndex].Text = browsers[bTabs.SelectedIndex].Source.ToString();
                    }

                    try
                    {
                        sourceImage = "http://" + browsers[bTabs.SelectedIndex].Source.Host + "/favicon.ico";
                        WebRequest request = (WebRequest)WebRequest.Create(sourceImage);
                        request.BeginGetResponse(GetCallback, request);
                    }
                    catch { favicon.Image = null; }
                }
            }
            catch { }
        }

        private void Awesomium_Windows_Forms_WebControl_AddressChanged(object sender, Awesomium.Core.UrlEventArgs e)
        {
            warningBox.Visible = false;
            bTabs.TabPages[bTabs.SelectedIndex].Text = "Navigating...";

            if (e.Url.ToString() != "about:blank")
            {
                //Add to the collection of items in the address bar combo box.
                url.Text = e.Url.ToString();
                url.Items.Add(e.Url.ToString());

                //Try to save to history.
                try
                {
                    if (tinfoilLbl.Visible == false)
                    {
                        Properties.Settings.Default.history.Add(e.Url.ToString());
                        Properties.Settings.Default.Save();
                    }
                }
                catch
                {
                }
                url.Select(0, 0);
                browsers[bTabs.SelectedIndex].Focus();
            }

            Image load = Image.FromFile("loading.gif");
            favicon.Image = load;
        }

        private void GetCallback(IAsyncResult result)
        {
            WebRequest request = result.AsyncState as WebRequest;
            if (request != null)
            {
                try
                {
                    WebResponse response = request.EndGetResponse(result);
                    Stream stream = response.GetResponseStream();
                    Image img = Image.FromStream(stream);
                    response.Close();
                    stream.Close();
                    stream.Dispose();

                    favicon.Image = img;
                }
                catch
                {
                    return;
                }
            }
        }

        private void Awesomium_Windows_Forms_WebControl_CertificateError(object sender, Awesomium.Core.CertificateErrorEventArgs e)
        {
            //Warn about certificate error to user!
            //First, show warning shield.
            warningBox.Visible = true;

            //Then, flash the form.
            this.Opacity = 0.5;
            warn.Interval = 500;
            warn.Enabled = true;
        }

        private void Awesomium_Windows_Forms_WebControl_ShowPopupMenu(object sender, PopupMenuEventArgs e)
        {
            lbSelect.Items.Clear();
            uint count = e.Info.Count;
            for (uint i = 0; i < count; i++)
                lbSelect.Items.Add(e.Info[i].Label);

            Rectangle lbb = new Rectangle
            {
                X = e.Info.Bounds.X,
                Y = e.Info.Bounds.Y + e.Info.Bounds.Height,
                Height = (count <= 10 ? (int)(e.Info.ItemHeight * count) : e.Info.ItemHeight * 10),
                Width = e.Info.Bounds.Width
            };

            lbSelect.Bounds = lbb;
            lbSelect.Visible = true;
            lbSelect.SelectedIndex = e.Info.SelectedItem;
            lbSelect.Focus();

            _MenuArgs = e;
        }

        private void lbSelect_MouseClick(object sender, MouseEventArgs e)
        {
            //The drop down menu has an item selected!
            _MenuArgs.Info.Select(lbSelect.SelectedIndex);
            lbSelect.Visible = false;
            browsers[bTabs.SelectedIndex].Focus();
        }

        private void lbSelect_LostFocus(object sender, EventArgs e)
        {
            //Hide the drop down menu after it loses focus.
            lbSelect.Visible = false;
        }

        private void stopToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Stop navigation, clear the image from favicon, and also change title text of form.
            browsers[bTabs.SelectedIndex].Stop();
            favicon.Image = null;
            bTabs.TabPages[bTabs.SelectedIndex].Text = "Stopped";
        }

        private void privateToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string[] args = { "interlight:tinfoil" };
            Form1 frm = new Form1(args);
            frm.Show();
        }

        private void viewSourceToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                //Get the source, using javascript.
                String source = browsers[bTabs.SelectedIndex].ExecuteJavascriptWithResult("document.getElementsByTagName('html')[0].innerHTML");
                textViewer tv = new textViewer();

                if (browsers[bTabs.SelectedIndex].HasTitle)
                {
                    tv.loadText("Interlight -> " + browsers[bTabs.SelectedIndex].Title + " [Source View]", source);
                }
                else
                {
                    tv.loadText("Interlight [Source View]", source);
                }
                tv.turnWrapOff();
                tv.Show();
            }
            catch
            {

            }
        }

        private void addToFavoritesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            settings obj = new settings();
            obj.currentPage(browsers[bTabs.SelectedIndex].Source.ToString());
            obj.selectTab(99);
            obj.ShowDialog();

            //CHECK IF NAVIGATION IS REQUESTED
            if (Properties.Settings.Default.navigateTo != "NONE")
            {
                try
                {
                    browsers[bTabs.SelectedIndex].Source = new Uri(Properties.Settings.Default.navigateTo);
                }
                catch
                {
                    try
                    {
                        browsers[bTabs.SelectedIndex].Source = new Uri("http://" + Properties.Settings.Default.navigateTo);
                    }
                    catch
                    {
                        MessageBox.Show("Failed to navigate.");
                    }
                }
                Properties.Settings.Default.navigateTo = "NONE";
            }
        }

        private void shrinkURLToBitlyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ShrinkURL url = new ShrinkURL();
            url.currentUrl = browsers[bTabs.SelectedIndex].Source.ToString();
            url.Show();
        }

        private void downloadFromURLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            addDownload dlFrm = new addDownload();
            dlFrm.ShowDialog();

            if (customDownloadURL != "")
            {
                lastDlURL = customDownloadURL;
                DownloadDialog dl = new DownloadDialog(customDownloadURL);
                dl.Show();
            }
        }

        private void saveTheWebpageToolStripMenuItem_Click(object sender, EventArgs e)
        {
            sourcesfd.Filter = "HTML Document|*.html|PDF Document|*.pdf|HTM Document|*.htm|Text File|*.txt|All Files|*.*";
            sourcesfd.DefaultExt = "html";
            sourcesfd.FileName = browsers[bTabs.SelectedIndex].Title.ToString();
            sourcesfd.ShowDialog();
        }

        private void sfd_FileOk(object sender, CancelEventArgs e)
        {
            if (Path.GetExtension(sourcesfd.FileName) == ".pdf")
            {
                try
                {
                    int requestID = browsers[bTabs.SelectedIndex].PrintToFile(Path.GetDirectoryName(sourcesfd.FileName), PrintConfig.Default);
                    isManualSavePage = true;
                    saveWebpageFilenameWithoutExtension = Path.GetFileNameWithoutExtension(sourcesfd.FileName);
                }
                catch
                {
                    MessageBox.Show("Interlight could not write to the path specified.", "Error");
                }
            }

            else
            {
                using (StreamWriter writer = new StreamWriter(sourcesfd.FileName))
                {
                    try
                    {
                        writer.WriteLine(browsers[bTabs.SelectedIndex].ExecuteJavascriptWithResult("document.getElementsByTagName('html')[0].innerHTML").ToString());
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show("An error occured during saving the webpage: " + ex.Message + Environment.NewLine +
                            Environment.NewLine + ex);
                    }
                    writer.Close();
                }
            }
        }

        private void printToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OnPrint();
        }

        private void OnPrint()
        {
            try
            {
                int requestID = browsers[bTabs.SelectedIndex].PrintToFile(Environment.ExpandEnvironmentVariables("%HOMEPATH%") + "\\Desktop", PrintConfig.Default);
            }
            catch
            {
                MessageBox.Show("Could not write to desktop!", "Error");
            }
        }

        private void Awesomium_Windows_Forms_WebControl_PrintRequest(object sender, PrintRequestEventArgs e)
        {
            e.Handled = true;
            this.OnPrint();
        }

        private void Awesomium_Windows_Forms_WebControl_PrintComplete(object sender, PrintCompleteEventArgs e)
        {
            if (isManualSavePage == false)
            {
                foreach (string file in e.Files)
                {
                    //file is a complete path
                    Process printproc = new Process();
                    printproc.StartInfo = new ProcessStartInfo()
                    {
                        CreateNoWindow = true,
                        Verb = "print",
                        FileName = file
                    };
                    try
                    {
                        printproc.Start();
                        MessageBox.Show("The webpage is being printed. If you do not need to re-print the webpage again, delete the PDF in your desktop after printing.", "Interlight - Printing");
                    }
                    catch
                    {
                        try
                        {
                            Process.Start(file);
                            MessageBox.Show("Interlight could not find a program on your computer that prints .PDF files. The webpage PDF on your desktop will be opened directly.", "Interlight - Printing");
                        }
                        catch
                        {
                            MessageBox.Show("An error occured while attempting to print. You can print the page manually by printing " + Path.GetFileName(file) + " from your desktop.", "Error");
                        }
                    }
                }
            }

            else
            {
                isManualSavePage = false;

                foreach (string file in e.Files)
                {
                    File.Move(file, Path.GetDirectoryName(file) + "\\" + saveWebpageFilenameWithoutExtension + ".pdf");
                }
            }
        }

        private void Awesomium_Windows_Forms_WebControl_PrintFailed(object sender, PrintOperationEventArgs e)
        {
            MessageBox.Show("The printing request failed.");
        }

        private void bTabs_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (bTabs.SelectedIndex == bTabs.TabPages.Count - 1)
            {
                newTab();
            }

            this.url.Text = browsers[bTabs.SelectedIndex].Source.ToString();
        }

        private void newTab()
        {
            int tIndex = bTabs.TabPages.Count - 1;
            creatingNewWC();
            browsers[tIndex].Source = (new Uri(Properties.Settings.Default.homeUrl));
        }

        private void creatingNewWC()
        {
            int tIndex = bTabs.TabPages.Count - 1;
            bTabs.TabPages[tIndex].Text = "Navigating...";
            browsers[tIndex] = new WebControl();
            browsers[tIndex].WebSession = session;
            bTabs.TabPages[tIndex].Controls.Add(browsers[tIndex]);
            browsers[tIndex].Dock = DockStyle.Fill;
            addEvents(tIndex);
            bTabs.TabPages.Add("+");
        }

        private void newTabWithoutButton(String url)
        {
            int tIndex = bTabs.TabPages.Count - 1;
            creatingNewWC();
            browsers[tIndex].Source = (new Uri(url));
        }

        private void addEvents(int index)
        {
            browsers[index].PrintRequest += Awesomium_Windows_Forms_WebControl_PrintRequest;
            browsers[index].PrintComplete += Awesomium_Windows_Forms_WebControl_PrintComplete;
            browsers[index].PrintFailed += Awesomium_Windows_Forms_WebControl_PrintFailed;
            browsers[index].ShowPopupMenu += Awesomium_Windows_Forms_WebControl_ShowPopupMenu;
            browsers[index].TitleChanged += Awesomium_Windows_Forms_WebControl_TitleChanged;
            browsers[index].CertificateError += Awesomium_Windows_Forms_WebControl_CertificateError;
            browsers[index].AddressChanged += Awesomium_Windows_Forms_WebControl_AddressChanged;
            browsers[index].LoadingFrameFailed += Awesomium_Windows_Forms_WebControl_LoadingFrameFailed;
            browsers[index].LoadingFrameComplete += Awesomium_Windows_Forms_WebControl_LoadingFrameComplete;
            browsers[index].LoadingFrame += Awesomium_Windows_Forms_WebControl_LoadingFrame;
            browsers[index].WindowClose += Awesomium_Windows_Forms_WebControl_WindowClose;
        }

        private void closeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Uri.IsWellFormedUriString(browsers[bTabs.SelectedIndex].Source.ToString(), UriKind.RelativeOrAbsolute))
            {
                lastTabOpen = browsers[bTabs.SelectedIndex].Source.ToString();
                Debug.WriteLine("Seems to be a valid URI... " + lastTabOpen);
            }
            if (bTabs.TabPages.Count == 2)
            {
                browsers[0].Source = (new Uri(Properties.Settings.Default.homeUrl));
            }
            else if (rightClickedTab != bTabs.TabPages.Count - 1)
            {
                closeTab(rightClickedTab);
            }
        }

        private void closeTab(int index)
        {
            bTabs.TabPages[index].Controls.Remove(browsers[index]);
            bTabs.TabPages.RemoveAt(index);
            browsers[index].Dispose();
        }

        private void bTabs_MouseUp(object sender, MouseEventArgs e)
        {
            // check if the right mouse button was pressed
            if (e.Button == MouseButtons.Right)
            {
                // iterate through all the tab pages
                for (int i = 0; i < bTabs.TabCount; i++)
                {
                    // get their rectangle area and check if it contains the mouse cursor
                    Rectangle r = bTabs.GetTabRect(i);
                    if (r.Contains(e.Location))
                    {
                        // show the context menu here
                        rightClickedTab = i;
                    }
                }
            }
        }

        private void url_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Enter)
            {
                e.SuppressKeyPress = true;
                //To prevent opening FTP links in Interlight, as Awesomium can't handle that...
                if (url.Text.StartsWith("ftp://"))
                {
                    System.Diagnostics.Process.Start("explorer.exe", url.Text);
                    return;
                }

                //Check if the URL is a valid one or not... If not, search the string instead.
                else if (Uri.IsWellFormedUriString(url.Text, UriKind.RelativeOrAbsolute) == false)
                {
                    search();
                }

                else if (!url.Text.Contains('.'))
                {
                    search();
                }

                else
                {
                    try
                    {
                        //It's probably a valid URL. Try navigating.
                        browsers[bTabs.SelectedIndex].Source = (new Uri(url.Text));
                    }
                    catch
                    {
                        try
                        {
                            //Maybe the user left out the "http".
                            browsers[bTabs.SelectedIndex].Source = (new Uri("http://" + url.Text));
                        }
                        catch
                        {
                            //Nope, it's not a valid URL...
                            MessageBox.Show("Failed to navigate.");
                        }
                    }

                    //Give the WebView focus again, so user may scroll.
                    browsers[bTabs.SelectedIndex].Focus();
                }
            }
        }

        private void reopenLastTabToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Debug.WriteLine("Reopening " + lastTabOpen);
            newTabWithoutButton(lastTabOpen);
            bTabs.SelectedIndex = bTabs.TabPages.Count - 2;
        }
    }
}