﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using Newtonsoft.Json;

namespace Interlight
{
    public partial class ShrinkURL : Form
    {
        public String currentUrl = "";

        public ShrinkURL()
        {
            InitializeComponent();
            service.SelectedIndex = 0;
        }

        private class googResult
        {
            //public String kind;
            public String id {get; set;}
            //public String longUrl;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            try
            {
                Clipboard.SetText(shortURL.Text);
            }
            catch { }
        }


        private void button1_Click(object sender, EventArgs e)
        {
            pb.Value = 0;
            #region bit.ly

            if (service.SelectedIndex == 0)
            {
                String longURL = longURLBox.Text;

                string url = string.Format(@"https://api-ssl.bitly.com/v3/shorten?format=txt&access_token={0}&longUrl={1}",
                 "db99865b52690e338d1c9d9b2ef2957b63230672", longURL);

                using (WebClient client = new WebClient())
                {
                    client.DownloadStringCompleted += client_DownloadStringCompleted;
                    client.DownloadStringAsync(new Uri(url));
                }

                pb.Value = 50;
            }

            #endregion

            #region goo.gl

            else if (service.SelectedIndex == 1)
            {
                string URI = "https://www.googleapis.com/urlshortener/v1/url";
                string myParameters = "{\"longUrl\": \"" + longURLBox.Text + "\"}";

                using (WebClient wc = new WebClient())
                {
                    wc.Headers[HttpRequestHeader.ContentType] = "application/json";
                    wc.UploadStringCompleted += wc_UploadStringCompleted;
                    wc.UploadStringAsync(new Uri(URI), myParameters);
                    pb.Value = 50;
                }
            }

            #endregion

            #region tinyurl

            else if (service.SelectedIndex == 2)
            {
                using (WebClient tinyClient = new WebClient())
                {
                    tinyClient.DownloadStringCompleted += tinyClient_DownloadStringCompleted;
                    tinyClient.DownloadStringAsync(new Uri("http://tinyurl.com/api-create.php?url=" + longURLBox.Text));
                    pb.Value = 50;
                }
            }

            #endregion
        }

        void tinyClient_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            shortURL.Text = e.Result;
            pb.Value = 100;
        }

        void wc_UploadStringCompleted(object sender, UploadStringCompletedEventArgs e)
        {
            googResult result = JsonConvert.DeserializeObject<googResult>(e.Result);
            shortURL.Text = result.id;
            pb.Value = 100;
        }

        private void ShrinkURL_Load(object sender, EventArgs e)
        {
            longURLBox.Text = currentUrl;
        }

        void client_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            shortURL.Text = e.Result;
            pb.Value = 100;
        }
    }
}
